// MyToday1.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "MenKal.h"
#include "time.h"

// nazvy dnu
TCHAR *dny[] = {_T("NE"), _T("PO"),_T("T"),_T("ST"),_T("T"),_T("P"),_T("SO")};
// nazvy mesicu
TCHAR *mesice[] = {_T("ledna"), _T("nora"),_T("bezna"),_T("dubna"),_T("kvtna"),_T("ervna"),_T("ervence"),_T("srpna"),_T("z"),_T("jna"),_T("listopadu"),_T("prosince")};


LPCTSTR g_lpcszClass = _T("MenKalWndClass");
LPCTSTR g_lpcszWnd = _T("MenKalWnd");
HWND g_mainWnd = NULL;
HINSTANCE g_hInstance = NULL;

// Icons to draw
HICON g_hAppIcon = NULL;

// Default settings for today fonts and texts
COLORREF g_crTodayText = NULL;
HFONT g_fontToday = NULL;

// text, ktery se vypisuje na obrazovku
TCHAR g_denText[] = TEXT("Den: ");
TCHAR g_text[100];
BOOL g_red = FALSE;

// citac pro obnovovani obsahu
int g_counter = 0;
// za kolik zprav WM_TODAYCUSTOM_QUERYREFRESHCACHE se bude kontrolovat datum
int POOL_INTERVAL = 5;
// stara hodnota cisla dne, slouzi pro detekci zmeny data
WORD g_oldDay = 0;
//
int g_den = 1;
DATA g_data;

BOOL CALLBACK SeznamDlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

int zacatekToDen(ULONGLONG zacatek, int delka) {
	SYSTEMTIME now;
	GetLocalTime(&now);
	now.wHour = 0;
	now.wMinute = 0;
	now.wSecond = 0;
	now.wMilliseconds = 0;

	ULONGLONG nanosec = SystemTimeToNanosec(&now);
	return (int)((nanosec - zacatek)/((ULONGLONG)24*60*60*10000000))%delka + 1;
}

ULONGLONG denToZacatek(int den) {
	SYSTEMTIME now;
	GetLocalTime(&now);
	now.wHour = 0;
	now.wMinute = 0;
	now.wSecond = 0;
	now.wMilliseconds = 0;

	roll(&now, 0, -1*(den-1));

	return SystemTimeToNanosec(&now);
}

void WriteDataToRegistry(DATA data);

void ReadDataFromRegistry(DATA *data) {
	LONG vysledek;// = RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("SOFTWARE\\Microsoft\\Today\\Items"),0,0,&hkey);
	DWORD disposition;
	HKEY hkey;

	vysledek = RegCreateKeyEx( HKEY_CURRENT_USER, TEXT("SOFTWARE\\MenKal"), 0, NULL, 0, 0, NULL, &hkey, &disposition);
	
	if (disposition == REG_CREATED_NEW_KEY) {
		data->delkaCyklu = 28;
		data->delkaMen = 5;
		data->zacatek = denToZacatek(1);

		WriteDataToRegistry(*data);
	}
	else {
		DWORD type  = REG_DWORD;
		DWORD delka = sizeof(DWORD);

		vysledek = RegQueryValueEx(hkey, TEXT("Dlka cyklu"), NULL, &type, (LPBYTE) &data->delkaCyklu, &delka);
		vysledek = RegQueryValueEx(hkey, TEXT("Dlka menstruace"), NULL, &type, (LPBYTE) &data->delkaMen, &delka);
		
		type = REG_BINARY;
		delka = sizeof(ULONGLONG);
		vysledek = RegQueryValueEx(hkey, TEXT("Zatek"), NULL, &type, (LPBYTE) &data->zacatek, &delka);
	}

	vysledek = RegCloseKey(hkey);

	return;
}

void WriteDataToRegistry(DATA data) {
	DWORD disposition;
	HKEY hkey;
	
	RegCreateKeyEx( HKEY_CURRENT_USER, TEXT("SOFTWARE\\MenKal"), 0, NULL, 0, 0, NULL, &hkey, &disposition);	

	RegSetValueEx(hkey, TEXT("Dlka cyklu"), NULL, REG_DWORD, (LPBYTE) &data.delkaCyklu, sizeof(DWORD));
	RegSetValueEx(hkey, TEXT("Dlka menstruace"), NULL, REG_DWORD, (LPBYTE) &data.delkaMen, sizeof(DWORD));
	RegSetValueEx(hkey, TEXT("Zatek"), NULL, REG_BINARY, (LPBYTE) &data.zacatek, sizeof(ULONGLONG));

	RegCloseKey(hkey);
}

void updateData(SYSTEMTIME systemTime) {
	//swprintf(g_text, _T("%s, %d. %s %d"), dny[systemTime.wDayOfWeek], systemTime.wDay, mesice[systemTime.wMonth-1], systemTime.wYear);
	g_den = zacatekToDen(g_data.zacatek, g_data.delkaCyklu);
	
	SYSTEMTIME next;
	int zbyva = g_data.delkaCyklu-g_den+1;
	next = systemTime;
	roll(&next, 0, zbyva);
	
	if (g_den <= (int) g_data.delkaMen) 
		g_red = TRUE;
	else
		g_red = FALSE;
	
	//swprintf(g_text, TEXT(", zbv: %d, dal: %d.%2d."), g_data.delkaCyklu-g_den, (int) next.wDay, (int) next.wMonth);
	swprintf(g_text, TEXT(", zbv: %d, dal: %d. %s"), g_data.delkaCyklu-g_den+1, (int) next.wDay, mesice[next.wMonth-1]);
}

///////////////////////////////////////// TODAY ITEM ///////////////////////////////////////////

BOOL APIENTRY DllMain(HANDLE hModule, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		// Just remember DLL instance
		g_hInstance = (HINSTANCE)hModule;

		// Unregister today window class
		UnregisterClass(g_lpcszClass, (HINSTANCE)hModule);

		// Register today window class
		WNDCLASS wndClass;
		memset(&wndClass, 0, sizeof(wndClass));
		wndClass.hCursor = 0;
		wndClass.hIcon = 0;
		wndClass.hInstance = (HINSTANCE)hModule;
		wndClass.lpszClassName = g_lpcszClass;
		wndClass.lpszMenuName = NULL;
		wndClass.style = CS_VREDRAW | CS_HREDRAW;
		wndClass.hbrBackground = (HBRUSH)GetStockObject(HOLLOW_BRUSH);
		wndClass.lpfnWndProc = WndProc;

		RegisterClass(&wndClass);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		// Destroy all allocated variables

		if (g_fontToday)
			DeleteObject(g_fontToday);

		if (g_hAppIcon)
			DeleteObject(g_hAppIcon);
	}

    return TRUE;
}

void GetTodayDefaults(HWND hWndParent)
{
	g_crTodayText = SendMessage(hWndParent, TODAYM_GETCOLOR, (WPARAM)TODAYCOLOR_TEXT, NULL);

	LOGFONT lf;
	HFONT hSysFont;

	// Default today fonts
	hSysFont = (HFONT)GetStockObject(SYSTEM_FONT);
	GetObject(hSysFont, sizeof(LOGFONT), &lf);

	HDC hdc = GetDC(g_mainWnd);

	lstrcpy(lf.lfFaceName, _T("Tahoma"));
	lf.lfHeight = -1 * (17 * GetDeviceCaps(hdc, LOGPIXELSY) / 72) / 2;

	ReleaseDC(g_mainWnd, hdc);

	// Normal text
	g_fontToday = CreateFontIndirect(&lf);

}

void LoadIcons()
{
	// Load app icon which will be drawn on the left of today item
	g_hAppIcon = (HICON)LoadImage(g_hInstance, MAKEINTRESOURCE(ID_APP_ICO), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
}

HWND APIENTRY InitializeCustomItem(TODAYLISTITEM *ptli, HWND hWndParent)
{
	// Check if item's enabled
	if (!ptli->fEnabled)
		return 0;

	// Set zero initial height
	ptli->cyp = 0;

	// Create window itself, with desired style
	// Again set its zero height
	g_mainWnd = CreateWindow(g_lpcszClass, g_lpcszWnd, WS_CHILD | WS_VISIBLE,
		                     // Set correct size
		                     0, 0, GetSystemMetrics(SM_CXSCREEN), 0,
							 hWndParent, NULL, ptli->hinstDLL, NULL);

	if (!g_mainWnd)
		return 0;

	// Get defaults for today screen
	GetTodayDefaults(hWndParent);

	// Load all icons needed
	LoadIcons();

	ReadDataFromRegistry(&g_data);
	
	SYSTEMTIME systemTime;
	GetLocalTime(&systemTime);
	g_oldDay = systemTime.wDay;
	updateData(systemTime);


	return g_mainWnd;
}


void DoPaint(HDC hDC)
{
	HFONT hFontOld;
	RECT rect;
	SIZE size;
	TCHAR pomText[10];

	// Set transparent background
	SetBkMode(hDC, TRANSPARENT);
	// Set font color to Today text one
	SetTextColor(hDC, g_crTodayText);

	// Draw Today item icon
	if (g_hAppIcon)
		DrawIconEx(hDC, 2, 1, g_hAppIcon,0,0,0,NULL, DI_NORMAL);

	//szText = _T("First line - bold font");
	hFontOld = (HFONT)SelectObject(hDC, g_fontToday);

	GetTextExtentPoint32(hDC, g_denText, _tcslen(g_denText), &size);
	rect.left = 30;
	rect.top = 2;
	rect.right = rect.left + size.cx;
	rect.bottom = size.cy+2;
	DrawText(hDC, g_denText, -1, &rect, DT_LEFT);	
	
	rect.left += size.cx;
	_itow( g_den, pomText, 10);
	GetTextExtentPoint32(hDC, pomText, _tcslen(pomText), &size);
	rect.right = rect.left + size.cx;
	rect.bottom = size.cy+2;
	if (g_red == TRUE)
		SetTextColor(hDC, RGB(255,0,0));
	DrawText(hDC, pomText, -1, &rect, DT_LEFT);

	if (g_red == TRUE)
		SetTextColor(hDC, g_crTodayText);
	rect.left += size.cx;
	GetTextExtentPoint32(hDC, g_text, _tcslen(g_text), &size);
	rect.right = rect.left + size.cx;
	rect.bottom = size.cy+2;
	DrawText(hDC, g_text, -1, &rect, DT_LEFT);

	SelectObject(hDC, hFontOld);
	
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{	
	switch (uMsg)
	{
	case WM_CREATE:
		{
			return 0;
		}
	case WM_PAINT :
		{
            PAINTSTRUCT ps;
            HDC hDC;

            hDC = BeginPaint(hWnd, &ps);

			// Draw Today Item
			DoPaint(hDC);

			EndPaint(hWnd, &ps);
		}

		break;
	case WM_ERASEBKGND :
		{
			HDC hDC = (HDC)wParam;
			TODAYDRAWWATERMARKINFO dwi;

			dwi.hdc = hDC;
			GetClientRect(hWnd, &dwi.rc);
			
			dwi.hwnd = hWnd;

			SendMessage(GetParent(hWnd), TODAYM_DRAWWATERMARK, 0, (LPARAM)&dwi);

			return TRUE;
		}
	case WM_TODAYCUSTOM_CLEARCACHE :
		{
			TODAYLISTITEM *ptli = (TODAYLISTITEM *)wParam;

			return FALSE;
		}
	case WM_TODAYCUSTOM_QUERYREFRESHCACHE :
		{
//			CTime time;


			TODAYLISTITEM *ptli = (TODAYLISTITEM *)wParam;

			if (ptli->cyp == 0)
			{
				ptli->cyp = 19;
				return TRUE;
			}

			g_counter++;

			if (g_counter % POOL_INTERVAL) {
				SYSTEMTIME systemTime;
				GetLocalTime(&systemTime);

		
				if (g_oldDay != systemTime.wDay) { // doslo ke zmene data
					//MessageBox(hWnd, TEXT("update"), TEXT("Info"), MB_OK);
					g_oldDay = systemTime.wDay;
					updateData(systemTime);


					return TRUE;
				}
			
			}


			return FALSE;
		}
	case WM_LBUTTONUP :
		{
			DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_SEZNAM), hWnd, SeznamDlgProc);

			return 0;
		}
	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

//////////////// DIALOG //////////
HFONT g_fontTitle = NULL;
int g_nTitleHeight = 23;
SHACTIVATEINFO g_sai;

// Support routine for drawing proper dialog title
void GetDefaultTitleFont(HWND hWnd)
{
	LOGFONT lf;
	TEXTMETRIC tm;
	HDC hdc;
	
	hdc = GetDC(hWnd);
	GetTextMetrics(hdc, &tm);
	memset(&lf, 0, sizeof (lf));
	lf.lfHeight = -1 * (17 * GetDeviceCaps(hdc, LOGPIXELSY) / 72) / 2;
	lf.lfWeight = FW_SEMIBOLD;
	lf.lfPitchAndFamily = tm.tmPitchAndFamily;
	lstrcpy(lf.lfFaceName, _T("Tahoma"));
	g_fontTitle = CreateFontIndirect(&lf);
	ReleaseDC(hWnd, hdc);
}

void DrawDialogTitle(HWND hWnd, HDC hDC, LPCTSTR title)
{
	if (lstrlen(title))
	{
		RECT rect, rectText;
		GetClientRect(hWnd, &rect);

		// Draw text
		HFONT hOldFont = (HFONT)SelectObject(hDC, g_fontTitle);
		SetTextColor(hDC, RGB(0, 0, 156));

		rectText.left = 8;
		rectText.top = 0;
		rectText.right = rect.right - rect.left;
		rectText.bottom = g_nTitleHeight;
		DrawText(hDC, title, -1, &rectText, DT_VCENTER);
		SelectObject(hDC, hOldFont);

		// And finally underline title
		HPEN hOldPen, hPen = (HPEN)GetStockObject(BLACK_PEN);
		rect.top = rect.top + g_nTitleHeight;
		rect.bottom = rect.top;

		hOldPen = (HPEN)SelectObject(hDC, hPen);
		Polyline(hDC, (LPPOINT)&rect, 2);
		SelectObject(hDC, hOldPen);
	}
}

//////////////////////////////////////////////////// SEZNAM ///////////////////////////////////////////

BOOL CALLBACK SeznamDlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch (uMsg)
	{
	case WM_INITDIALOG :
		{
			// Initialize structure for WM_SETTINGCHANGE and WM_ACTIVATE
			memset(&g_sai, 0, sizeof(SHACTIVATEINFO));
			g_sai.cbSize = sizeof(SHACTIVATEINFO);

			// lParam contains pointer to Today Item Structure
			TODAYLISTITEM *ptli = (TODAYLISTITEM*)lParam;

			// We need to do correct initialization of our dialog
			SHINITDLGINFO shidi;
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN;
			shidi.dwFlags |= SHIDIF_SIZEDLGFULLSCREEN /*SHIDIF_FULLSCREENNOMENUBAR*/;
			shidi.hDlg = hWnd;

			SHInitDialog(&shidi);

			// Now we can get default title font
			// Optional - just for better look as recommended by Microsoft
			GetDefaultTitleFont(hWnd);

			RECT clientRect;
			HWND seznamHandle;
			GetClientRect(hWnd, &clientRect);
			seznamHandle = GetDlgItem(hWnd, IDC_SEZNAM);

			SetWindowPos( seznamHandle, HWND_TOP, clientRect.left, clientRect.top, clientRect.right-clientRect.left, clientRect.bottom-clientRect.top, 0); 
			//SetWindowRgn( seznamHadnle, clientRect, TRUE);
			TCHAR text[50];
			SYSTEMTIME datum;

			GetLocalTime(&datum);
			datum.wHour = datum.wMinute = datum.wMilliseconds = 0;
			roll(&datum, 0, (int) -1*g_den+1);

			//_itow( datum.wYear, text, 10);
			
			//MessageBox(hWnd, text, TEXT("Info"), MB_OK);

			for (int i = 0; i < 24; i++) {
				roll(&datum, 0, g_data.delkaCyklu);
				swprintf(text, TEXT("%s, %d. %s %d"), dny[datum.wDayOfWeek], datum.wDay, mesice[datum.wMonth-1], datum.wYear);
				SendMessage( seznamHandle, LB_ADDSTRING, 0, (LPARAM) text );
			}

			return TRUE;
		}
	case WM_SETTINGCHANGE :
		{
			SHHandleWMSettingChange(hWnd, wParam, lParam, &g_sai);
		}

		return 0;
	case WM_ACTIVATE :
		{
			SHHandleWMActivate(hWnd, wParam, lParam, &g_sai, FALSE);
		}

		return 0;
	case WM_PAINT :
		{
            PAINTSTRUCT ps;
            HDC hDC;

            hDC = BeginPaint(hWnd, &ps);

			// Draw title bar for our dialog
			//DrawDialogTitle(hWnd, hDC, g_lpcszOptions);

			EndPaint(hWnd, &ps);
		}

		break;
					
	case WM_COMMAND :
		{
			UINT nID = LOWORD(wParam);

			// Handle closing of dialog
			if (nID == IDOK)
			{
				// Destroy title font
				if (g_fontTitle)
					DeleteObject(g_fontTitle);

				EndDialog(hWnd, IDOK);

				return 0;
			}
		}

		break;
	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
	


/////////////////////////////////////////////////// NASTAVENI /////////////////////////////////////////
//CreateUpDownControl

// Option Dialog
LPCTSTR g_lpcszOptions = _T("Nastaven");

LRESULT WINAPI CustomItemOptionsDlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_INITDIALOG :
		{
			// Initialize structure for WM_SETTINGCHANGE and WM_ACTIVATE
			memset(&g_sai, 0, sizeof(SHACTIVATEINFO));
			g_sai.cbSize = sizeof(SHACTIVATEINFO);

			// lParam contains pointer to Today Item Structure
			TODAYLISTITEM *ptli = (TODAYLISTITEM*)lParam;

			// We need to do correct initialization of our dialog
			SHINITDLGINFO shidi;
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN;
			shidi.dwFlags |= SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hWnd;

			SHInitDialog(&shidi);

			// Now we can get default title font
			// Optional - just for better look as recommended by Microsoft
			GetDefaultTitleFont(hWnd);

			DATA data;

			ReadDataFromRegistry(&data);
			g_den = zacatekToDen(data.zacatek, data.delkaCyklu);
			
			SendDlgItemMessage(hWnd, IDC_SPIN_D_CYKLU, UDM_SETRANGE, (WPARAM) 0, (LPARAM)MAKELONG(50,10));
			SendDlgItemMessage(hWnd, IDC_SPIN_D_CYKLU, UDM_SETPOS, (WPARAM) 0, (LPARAM)MAKELONG(data.delkaCyklu,0));

			SendDlgItemMessage(hWnd, IDC_SPIN_DEN, UDM_SETRANGE, (WPARAM) 0, (LPARAM)MAKELONG(data.delkaCyklu,1));
			SendDlgItemMessage(hWnd, IDC_SPIN_D_MEN, UDM_SETRANGE, (WPARAM) 0, (LPARAM)MAKELONG(data.delkaCyklu,1));

			SendDlgItemMessage(hWnd, IDC_SPIN_DEN, UDM_SETPOS, (WPARAM) 0, (LPARAM)MAKELONG(g_den,0));
			SendDlgItemMessage(hWnd, IDC_SPIN_D_MEN, UDM_SETPOS, (WPARAM) 0, (LPARAM)MAKELONG(data.delkaMen,0));

			return TRUE;
		}
	case WM_SETTINGCHANGE :
		{
			SHHandleWMSettingChange(hWnd, wParam, lParam, &g_sai);
		}

		return 0;
	case WM_ACTIVATE :
		{
			SHHandleWMActivate(hWnd, wParam, lParam, &g_sai, FALSE);
		}

		return 0;
	case WM_PAINT :
		{
            PAINTSTRUCT ps;
            HDC hDC;

            hDC = BeginPaint(hWnd, &ps);

			// Draw title bar for our dialog
			DrawDialogTitle(hWnd, hDC, g_lpcszOptions);

			EndPaint(hWnd, &ps);
		}

		break;
	case WM_VSCROLL:
	{
		//MessageBox(hWnd, TEXT("WM_HSCROLL"), TEXT("Info"), MB_OK);
		if ((HWND) lParam == GetDlgItem(hWnd, IDC_SPIN_D_CYKLU) && (int)LOWORD(wParam) == SB_ENDSCROLL) {
			int delka = (short int)HIWORD(wParam);
			SendDlgItemMessage(hWnd, IDC_SPIN_DEN, UDM_SETRANGE, (WPARAM) 0, (LPARAM)MAKELONG(delka,1));
			SendDlgItemMessage(hWnd, IDC_SPIN_D_MEN, UDM_SETRANGE, (WPARAM) 0, (LPARAM)MAKELONG(delka,1));
			if (SendDlgItemMessage(hWnd, IDC_SPIN_D_MEN, UDM_GETPOS, (WPARAM) 0, (LPARAM) 0) > delka)
				SendDlgItemMessage(hWnd, IDC_SPIN_D_MEN, UDM_SETPOS, (WPARAM) 0, (LPARAM)MAKELONG(delka,0));
			if (SendDlgItemMessage(hWnd, IDC_SPIN_DEN, UDM_GETPOS, (WPARAM) 0, (LPARAM) 0) > delka)
				SendDlgItemMessage(hWnd, IDC_SPIN_DEN, UDM_SETPOS, (WPARAM) 0, (LPARAM)MAKELONG(delka,0));

		}
		return 0;
	}


					
	case WM_COMMAND :
		{
			UINT nID = LOWORD(wParam);

			// Handle closing of dialog
			if (nID == IDOK)
			{
				DATA data;
				
				data.delkaCyklu = SendDlgItemMessage(hWnd, IDC_SPIN_D_CYKLU, UDM_GETPOS, (WPARAM) 0, (LPARAM) 0);
				data.delkaMen = SendDlgItemMessage(hWnd, IDC_SPIN_D_MEN, UDM_GETPOS, (WPARAM) 0, (LPARAM) 0);				
				g_den = SendDlgItemMessage(hWnd, IDC_SPIN_DEN, UDM_GETPOS, (WPARAM) 0, (LPARAM) 0);
				data.zacatek = denToZacatek(g_den);

				WriteDataToRegistry(data);
				
				// Destroy title font
				if (g_fontTitle)
					DeleteObject(g_fontTitle);

				EndDialog(hWnd, IDOK);

				SYSTEMTIME systemTime;
				GetLocalTime(&systemTime);
				updateData(systemTime);
				
				return 0;
			}
		}

		break;
	}

	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

/*BOOL APIENTRY CustomItemOptionsDlgProc(HWND hDlg, UINT message,
  UINT wParam, LONG lParam)
{
	switch (message) 
	{
		case WM_INITDIALOG:
			return TRUE; 

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK) {
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
		//case WM_CTLCOLORSTATIC:
		//	break;
		default:
			return DefWindowProc(hDlg, message, wParam, lParam);
   }
   return 0;
}*/


/*		UINT nID = LOWORD(wParam);
		TCHAR text[10];
		if (nID == IDC_SPIN_D_CYKLU) {				
			LPNMHDR pnhm = (LPNMHDR) lParam;
			if (pnhm->idFrom == IDC_SPIN_D_CYKLU/*&& pnhm->code == UDN_DELTAPOS*//*) {
	//			MessageBox(hWnd, _itow(pnhm->code, text, 10)/*TEXT("ted2")*//*, /*TEXT("Info") /*_itow(lParam, text, 10)*//*, MB_OK);
/*				NMUPDOWN *lpnmud = (NM_UPDOWN FAR *) lParam;
				int pos = lpnmud->iPos;
				//MessageBox(hWnd, _itow(pos, text, 10)/*TEXT("ted2")*//*, /*TEXT("Info") /*_itow(lParam, text, 10)*//*, MB_OK);
/*				return 0;
			}
/*			NMUPDOWN *lpnmud = (NM_UPDOWN FAR *) lParam;
			if (lpnmud->hdr.idFrom == IDC_SPIN_D_CYKLU && lpnmud->hdr.code == UDN_DELTAPOS) {
				TCHAR text[10];
				MessageBox(hWnd, _itow(lpnmud->iPos, text, 10), TEXT("Info"), MB_OK);			
			}*/

/*		}*/
