#include "stdafx.h"

/* Prevede cas ze struktury SYSTEMTIME hodnoty vyjadrujici pocet
   100-vek nanosekun od 1.1.1601 */
ULONGLONG SystemTimeToNanosec(SYSTEMTIME *systemTime) {
	FILETIME fileTime;
	ULONGLONG milisec;

	SystemTimeToFileTime(systemTime, &fileTime);
	memcpy( &milisec, &fileTime, sizeof(milisec));
	
	return milisec;
}

/* Prevede cas z hodnoty vyjadrujici pocet 100-vek nanosekun od 1.1.1601 
   do struktury SYSTEMTIME */
void NanosecToSystemTime(ULONGLONG nanosec, SYSTEMTIME *systemTime) {
	FILETIME fileTime;
	
	memcpy( &fileTime, &nanosec, sizeof(fileTime));
	FileTimeToSystemTime(&fileTime, systemTime);
}


/* Provede korektni posun mesicu, dnu, hodin, minut a vterin ve strukture SYSTEMTIME */
void roll(SYSTEMTIME *systemTime, int months, int days = 0, int hours = 0, int minutes = 0, int seconds = 0) {
	ULONGLONG nanosec;

	if (months != 0) {
		int month = systemTime->wMonth;
		month += months;
		if (month < 1) {
			int temp = 1 - month;
			systemTime->wYear -= temp / 12 + 1;
			month = 13 - temp % 12;
		} else if (month > 12) {
			int temp = month - 1;
			systemTime->wYear += temp / 12;
			month= temp % 12 + 1;
		}
		systemTime->wMonth = month;
	}
	
	nanosec = SystemTimeToNanosec(systemTime);
	nanosec += (ULONGLONG) (((days*24 + hours)*60 + minutes)*60 + seconds)*10000000;

	NanosecToSystemTime(nanosec, systemTime);
}
